<% local view, viewlibrary = ... 
require("viewfunctions")
%>

<script type="text/javascript" src="/js/jquery-latest.js"></script>
<script type="text/javascript">
	var last_phrase = "";
	function filterPage(){
		var phrase = $("#filter").val();
		if (phrase != last_phrase){
			last_phrase = phrase;
			$("#records li").each(function(){
				var elem = jQuery(this);
				if (elem.text().indexOf(phrase)>=0) {
					elem.show();
				} else {
					elem.hide();
				}
			});
		}
	}
	function toggleEntry(){
		$(this).find("table").toggle();
		$(this).find("pre").toggle();
	}
	function editEntry(){
		window.location.href = "edit?" + this.id;
	}
	var filterTimer;
	$(function(){
		$("#filter").keyup(function(){
			window.clearTimeout(filterTimer);
			filterTimer = window.setTimeout("filterPage();",250);
		});
		$("#filter-list").submit(function(){
			return false;
		}).focus();
		$("#records pre").hide();
		$("#records li").not(":has(ul)").click(toggleEntry);
		$("#records li").not(":has(ul)").dblclick(editEntry);
		$("#locations li").not(":has(ul)").dblclick(editEntry);
	});
</script>

<%
--[[ DEBUG INFORMATION
io.write("<H1>DEBUGGING</H1><span style='color:red'><H2>DEBUG INFO: CFE</H2>")
io.write(html.cfe_unpack(view))
io.write("</span>")
--]]
%>

<H1>DNS Entries
<% if view.filename then io.write(" for "..html.html_escape(string.gsub(view.filename, "^.*/", ""))) end %>
</H1>
<H2>Locations</H2>
<DL id="locations">
<ul>
<% local currentloc = ""
for i,loc in ipairs(view.value) do
	if loc.type == '%' then
		if currentloc ~= loc[1] then
			if currentloc ~= "" then %>
				</ul>
			<% end %>
			<li><IMG SRC='/skins/static/tango/16x16/places/start-here.png' width='16' height='16' alt> <B><%= html.html_escape(loc[1]) %></B></li>
			<ul STYLE='margin-left:30px';>
		<% end
		currentloc = loc[1] %>
		<li id='filename=<%= html.html_escape(loc.filename) %>;linenumber=<%= html.html_escape(loc.linenumber) %>'>
		<%= html.html_escape(loc[2]) %><% if loc[2] == "" then io.write('*') end %>
		<% if (loc.errtxt) then %><P CLASS='error'><%= string.gsub(html.html_escape(loc.errtxt), "\n", "<BR>") %></P><% end %>
		</li>
	<% end
end %>
<% if currentloc == "" then %>
	No locations defined
<% else %>
	</ul>
<% end %>
</ul>
</DL>

<%
local function doListIndents(next, indent)
	local newentry = {}
	for mt in string.gmatch(next, "([^.]+)") do
		table.insert(newentry, mt)
	end
	local revnewentry = {}
	for j=#newentry,1,-1 do
		table.insert(revnewentry, newentry[j])
	end
	local i=1
	while indent[i] and revnewentry[i] == indent[i] do
		i=i+1
	end
	local ending = #indent-(i-1)
	local starting = #newentry-(i-1)
	for j=1,ending do
		io.write("</li></ul>\n")
	end
	for j=1,starting do
		io.write("<ul><li STYLE='margin-left:10px;'><strong>")
		io.write(html.html_escape(table.concat(newentry, ".", #newentry-(i+j-2), #newentry)))
		io.write("</strong>\n")
	end
	return revnewentry
end
%>

<H2>Records</H2>
<form id="filter-list">Filter: <input name="filter" id="filter" value="" maxlength="30" size="30" type="text"></form>
<DL id="records">
<ul>
<% local indent = {}
for j,entry in ipairs(view.value) do 
	if entry.type ~= '%' then
		indent = doListIndents(entry[1], indent) %>
		<ul><li STYLE='margin-left:10px;' id='filename=<%= html.html_escape(entry.filename) %>;linenumber=<%= html.html_escape(entry.linenumber) %>'>
		<IMG SRC='/skins/static/tango/16x16/devices/computer.png' width='16' height='16'><%= html.html_escape(entry.label) %><BR>
		<pre><%= html.html_escape(entry.configline) %></pre>
		<TABLE STYLE='margin-left:<%= html.html_escape(tostring(7-#indent)) %>0px;'>
		<% for k=2,#entry do
			local option = entry[k]
			if (option) and option ~= "" then %>
				<TR><TD WIDTH='160px' STYLE='border:none;'><%= html.html_escape(view.fieldlabels[entry.type][k]) %>:</TD>
				<TD STYLE='border:none;'><%= html.html_escape(option) %></TD></TR>
			<% end
		end %>
		</TABLE>
		<% if entry.errtxt then %>
			<P CLASS='error'><%= string.gsub(html.html_escape(entry.errtxt), "\n", "<BR>") %></P>
		<% end %>
		</li></ul>
	<% end 
end
if #indent == 0 then %>
	No records defined
<% else
	doListIndents("", indent)
end %>
</ul>
</DL>
